# Cloud Foundry Garden Observer Extension

<!-- status autogenerated section -->
| Status        |           |
| ------------- |-----------|
| Stability     | [development]  |
| Distributions | [] |
| Issues        | [![Open issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aopen%20label%3Aextension%2Fcfgardenobserver%20&label=open&color=orange&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aopen+is%3Aissue+label%3Aextension%2Fcfgardenobserver) [![Closed issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aclosed%20label%3Aextension%2Fcfgardenobserver%20&label=closed&color=blue&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aclosed+is%3Aissue+label%3Aextension%2Fcfgardenobserver) |
| [Code Owners](https://github.com/open-telemetry/opentelemetry-collector-contrib/blob/main/CONTRIBUTING.md#becoming-a-code-owner)    | [@crobert-1](https://www.github.com/crobert-1), [@cemdk](https://www.github.com/cemdk), [@tomasmota](https://www.github.com/tomasmota), [@m1rp](https://www.github.com/m1rp), [@jriguera](https://www.github.com/jriguera) |

[development]: https://github.com/open-telemetry/opentelemetry-collector#development
<!-- end autogenerated section -->

Cloud Foundry (CF) is a platform as a service (PaaS) which has implemented their own container technology. The component in charge of providing a local API in each node (also known as "diego-cell") is named Garden.

The `cfgarden_observer` looks at the current host to discover Garden containers.

## Example Config

```yaml
extensions:
  cfgarden_observer:
    # url of the Garden socket, defaults to unix:///var/vcap/data/garden/garden.sock 
    endpoint: my/path/to/garden.sock
    # determines how often to look for changes in endpoints.
    refresh_interval: 30s

receivers:
  receiver_creator:
    watch_observers: [cfgarden_observer]
    receivers:
      prometheus_simple:
        rule: type == "container" && name == "myapp"
        config:
          metrics_path: /metrics
          endpoint: '`endpoint`'
```

### Configuration

| Name             | Type   | Default                                  | Docs                                                   |
|------------------|--------|------------------------------------------|--------------------------------------------------------|
| refresh_interval | string | 60s                                      | Determines how often to look for changes in endpoints. |
| endpoint         | string | unix:///var/vcap/data/garden/garden.sock | The endpoint to connect to the Garden API.             |

### Endpoint Variables

Endpoint variables exposed by this observer are as follows.

| Variable  | Description                                                                                |
|-----------|--------------------------------------------------------------------------------------------|
| type      | this value is always `container`                                                                              |
| name      | name of the Garden container associated to the port                                        |
